/******************************************************************************/
/*                                                                            */
/*      Tv            NXpbP[Wc[                              */
/*      \            PackageNX, ClassNX, js.cptpbP[W          */
/*      ŏIXV      2007/08/25(Sat)                                       */
/*      o[W      2.04.00                                               */
/*      쌠\      Copyright (C) 2005-2007 Mug, All rights reserved.     */
/*      tqk          http://www2.u-netsurf.ne.jp/~mug/                     */
/*                                                                            */
/******************************************************************************/

//:V Package Function js.cpt.PackageNX
var Package;
//:V Class Function js.cpt.ClassNX
var Class;
//:V include Function include\bh
var include;
//:V globalize Function globalize\bh
//var globalize;

(function()
  {
  //##############################################################################
  //
  // ʒ萔
  //
  //
  // NXpbP[Wʒ萔 - CPTKpƂɋʂȒ萔
  //
  //:V SUPERCLASS String X[p[NXɑ΂ANZX
  var SUPERCLASS = "Super";
  //:V EXTENSIONS String p\ȃNXõzXgIuWFNg
  var EXTENSIONS = "Static";
  //:V INTERFACES String C^[tF[XXg̃IuWFNg
  var INTERFACES = "Interfaces";
  //:V PACKAGEOBJ String pbP[WIuWFNg
  var PACKAGEOBJ = "package";
  //------------------------------------------------------------------------------
  //:V ROOT_PACKAGE_NAME String [gpbP[W̊SC
  var ROOT_PACKAGE_NAME = "js.cpt";
  //
  // `FbN萔 - e핶`FbN̂߂̒萔
  //
  //:V ONE_NAME_REG RegExp epbP[WƃNX̐K\
  var ONE_NAME_REG = /^[A-Za-z_][0-9A-Za-z_]*$/;
  //:V COMP_NAME_REG RegExp SC̐K\
  var COMP_NAME_REG = /^[A-Za-z_][0-9A-Za-z_]*(?:\.[A-Za-z_][0-9A-Za-z_]*)*$/;
  //:V INCLUDE_NAME_REG RegExp CN[hɎwł銮SCNX̐K\
  var INCLUDE_NAME_REG = /^(?:[A-Za-z_][0-9A-Za-z_]*\.)*(?:(?:[A-Za-z_][0-9A-Za-z_]*)|\*)$/;
  //:V INCLUDE_PACKAGE String ClassIuWFNgɁA̐include܂ł̊Ԃɕۑ`֐̃|C^
  var INCLUDE_PACKAGE = "creator";
  //
  // vCx[gϐ - Joƃ\bh
  //
  //:V PackageMap Object pbP[W`t@C}bviL[=pbP[W`ʒu,l=`֐j
  var PackageMap = {};
  //:V DefListMap Object pbP[W`Xg}bviL[=pbP[W`ʒu,l=̒`t@CŒ`NX̊SCNX̃Xgj
  var DefListMap = {};
  //:V DefineMap Object NX`}bviL[=SCNX,l=ClassIuWFNgj
  var DefineMap = {};
  //:V CreatorMap Object NG[^[}bviL[=SCNX,l=NG[^[֐j
  var CreatorMap = {};
  //:V ClassLoader Function|null NX[_[\bh
  var ClassLoader = null;
  //------------------------------------------------------------------------------
  //:V GLOBAL_OBJ Object O[oIuWFNg
  var GLOBAL_OBJ = (function(){return this;})();
  //:V FUNC_PROTO Object Function.prototype̎Q
  var FUNC_PROTO = (function(){}).constructor.prototype;
  //:V NATIVE_OBJECT Function ObjectRXgN^̎Q
  var NATIVE_OBJECT = ({}).constructor;
  
  //##############################################################################
  //
  // pbP[W
  //
  //
  // vCx[gϐ - Joƃ\bh
  //
  //------------------------------------------------------------------------------
  function getPackage(completeName, creative)
   /**
    * pbP[W擾
    * @notice ̃\bḧ͕K^`FbNς݂ł邱ƁB
    * @param completeName String SCpbP[W
    * @param creative [Boolean] ݂ȂꍇɃpbP[W쐬邩ǂ(ȗ:false)
    * @return js.cpt.Package|null ΉpbP[W
    * @notice ̈قȂIuWFNg݂ꍇ͐VKpbP[W쐬邱ƂłȂB
    */
    {
    var baseObject = GLOBAL_OBJ;
    if(completeName)
      {
      var nameList = completeName.split(".");
      for(var i = 0; i < nameList.length; i++)
        {
        var nextObject = baseObject[nameList[i]];
        if((nextObject === undefined) && creative)
          {
          nextObject = new _Package_();
          baseObject[nameList[i]] = nextObject;
          }
        else if(!nextObject || ((typeof nextObject) != "object") || !(nextObject instanceof _Package_))
          {
          baseObject = null;
          break;
          }
        baseObject = nextObject;
        }
      }
    return baseObject;
    }
  
  //------------------------------------------------------------------------------
  function regist(Class, completeName)
   /**
    * NXpbP[Wɓo^
    * @notice ̃\bḧ͕K^`FbNς݂ł邱ƁB
    * @param Class Function NX
    * @param completeName String SCNX
    * @return Boolean Vo^ǂ(true:VKo^/false:ɓo^ς)
    * @throw SystemError@Error SCNXz肳pbP[W擾łȂꍇ
    * @throw SystemError@Error SCNXŎw肳ꂽϐɂłɈقȂIuWFNg݂Ăꍇ
    */
    {
    var isSuccess   = false;
    var nameList    = completeName.split(".");
    var className   = nameList[nameList.length - 1];
    var packageName = null;
    if(nameList.length > 1)
      {
      packageName = completeName.substring(0, (completeName.length - 1 - className.length));
      }
    var baseObject = GLOBAL_OBJ;
    if(packageName)
      {
      baseObject = getPackage(packageName, true);
      }
    // ΉpbP[WpӂłȂꍇ
    if(!baseObject)
      {
      throw new Error("SystemError", ("pbP[W"+packageName+"擾ł܂łB"));
      }
    // \zO̐VKo^̏ꍇ
    else if(baseObject[className] === undefined)
      {
      Class[PACKAGEOBJ] = baseObject;
      baseObject[className] = Class;
      isSuccess = true;
      }
    // \肳ꂽVKo^̏ꍇ
    else if(baseObject[className] && ((typeof baseObject[className]) == "object") && (baseObject[className] instanceof _Class_))
      {
      if(getIncludePackageName(baseObject[className][INCLUDE_PACKAGE]))
        {
        addDefinedClass(baseObject[className][INCLUDE_PACKAGE], completeName);
        }
      delete baseObject[className][INCLUDE_PACKAGE];
      DefineMap[completeName] = baseObject[className];
      Class[PACKAGEOBJ] = baseObject;
      baseObject[className] = Class;
      isSuccess = true;
      }
    // o^ς݂̏ꍇ
    else if(baseObject[className] == Class)
      {
      isSuccess = false;
      }
    // قȂ̂ɂꍇ
    else
      {
      throw new Error("SystemError", ("ʂ̃IuWFNg݂邽"+completeName+"㏑ł܂B"));
      }
    return isSuccess;
    }
  
  //
  // PackageNX
  //
  //------------------------------------------------------------------------------
  var PackageCreator = function(Super)
   /**
    * upbP[WvNX
    * @param Super Function X[p[NX
    * @return Function js.cpt.PackageNX
    * 
    * @package js.cpt
    * @update 2007/03/10
    * @version 2.03.04
    * @author Mug
    * @copyright (C) 2005-2007 Mug, All rights reserved.
    * 
    * @explanation <p>̃NXCPT(ClassPackagingTool)̃pbP[WCX^X𐶐ƂɎgpB<br />
    *   ʏ<kbd>Package.getInstance()</kbd>i=SCpbP[WjŃCX^X擾B<br />
    *   ̂ƂAYpbP[W݂Ȃ΃\bhŐVɐĕԂB</p>
    *   <p><kbd>Package.getInstance()</kbd>\bh<kbd>Package.getPackage()</kbd>\bhƂ̈Ⴂ́A
    *   <kbd>getInstance</kbd>pbP[W`t@CŎgpړIł̂ɑ΂A
    *   <kbd>getPackage</kbd>͒ʏ̃\[XŎgpړIƂȂĂB<br />
    *   ɂ͋@\IȈႢ͂قƂǂȂA擾łIuWFNǧ`͓ƂȂB</p>
    * @example <p>pbP[W`t@C͈ȉiĵ悤ɒ`B<br />
    *   ł́Acom.sample.test.formpbP[WTextBoxManagerNX̏𐶐镔ƂB
    *   TextBoxManagerNX́Acom.sample.test.ElementManagerNXcom.sample.test.TextEditerNXɈˑA
    *   TextBoxManagerNX̃XNvgt@C̊gq.jsCtypetext/javascriptCR[hUTF-8̏ꍇłB</p>
    *   <pre><code>
    *   (function() {
    *     
    *     // com.sample.test.formpbP[W̐
    *     var pkg = Package.getInstance("com.sample.test.form");
    *     
    *     // TextBoxManagerNX̐
    *     pkg.TextBoxManager = new Class("TextBoxManager",
    *       ["com.sample.test.ElementManager", "com.sample.test.TextEditer"],
    *       "extension=.js,type=text/javascript,charset=UTF-8"
    *     );
    *     
    *   })();
    *   </code></pre>
    *   <p>̃Tvł́A܂<kbd>Package.getInstance("pbP[W")</kbd>ɂpbP[WIuWFNg擾A
    *   <kbd>pbP[WIuWFNg.NX = new Class("NX", ˑ惊Xg, IvV);</kbd>ƂăNX쐬ĂB</p>
    * @rel js.cpt.Class
    */
    {
    //##############################################################################
    //
    // wb_(vpeBEpENXpX)
    //
    //
    // vpeB - NXɊւ郁^f[^
    //
    //:V Creator Function NXNG[^[
    var Creator = arguments.callee;
    // String SCNX
    Creator.CompleteName = (ROOT_PACKAGE_NAME + ".Package");
    
    //
    // p - vg^CvpƊ{õZbg
    //
    // p
    Creator.inherit(Class, Super);
    //:V Static Object StaticIuWFNg
    var Static = Class.Static;
    //:V Proto Object vg^Cv
    var Proto = Class.prototype;
    
    //
    // NXpX
    //
    
    //##############################################################################
    //
    // {fB(vCx[gENXEStaticEvg^CvE)
    //
    //
    // vCx[g - NX̔Joƃ\bh(pȂ)
    //
    
    //
    // NX - NX̌Joƃ\bh(pȂ)
    //
    //------------------------------------------------------------------------------
    Class.getInstance = function(completeName, creative)
     /**
      * js.cpt.PackageNX̃CX^X(pbP[WIuWFNg)擾
      * @condition completeName͐K\COMP_NAME_REG𖞂KvB
      * @notice creativeȗꍇAtrueƂ݂Ȃ̂ŒӁB
      * @param completeName String SCpbP[W
      * @param creative [Boolean] ݂ȂꍇɃpbP[W쐬邩ǂ(ȗ:trueyӁz)
      * @return js.cpt.Package ΉpbP[WCX^X
      * @throw StringFormatException@Error completeNamev~eBuString^łȂꍇ
      * @throw StringRangeException@Error completeName󕶎ł邩Aw̐K\𖞂ĂȂꍇ
      * @throw BooleanFormatException@Error creative`łv~eBuBoolean^łȂꍇ
      * @throw SystemError@Error ΉpbP[W擾܂͐łȂꍇ
      */
      {
      if((typeof completeName) != "string")
        {
        throw new Error("StringFormatException", Creator.CompleteName, {variable:"completeName", value:completeName, type:(typeof completeName)});
        }
      if(!completeName || !COMP_NAME_REG.test(completeName))
        {
        throw new Error("StringRangeException", Creator.CompleteName, {variable:"completeName", range:("NotEmpty & /"+COMP_NAME_REG.source+"/"), value:completeName});
        }
      if(creative === undefined)
        {
        creative = true;
        }
      else if((typeof creative) != "boolean")
        {
        throw new Error("BooleanFormatException", Creator.CompleteName, {variable:"creative", value:creative, type:(typeof creative)});
        }
      var ins = getPackage(completeName, creative);
      if(!ins)
        {
        throw new Error("SystemError", Creator.CompleteName, "pbP[W̎擾܂͐Ɏs܂B");
        }
      registIncludePackage(arguments.callee.caller, completeName);
      return ins;
      };
    //------------------------------------------------------------------------------
    Class.getPackage = function(completeName)
     /**
      * pbP[W擾
      * @condition completeName͐K\COMP_NAME_REG𖞂KvB
      * @param completeName String SCpbP[W
      * @return js.cpt.Package|null ΉpbP[W(݂Ȃꍇnull)
      * @thorw StringFormatException@Error completeNamev~eBuString^łȂꍇ
      * @throw StringRangeException@Error completeName󕶎ł邩Aw̐K\𖞂ĂȂꍇ
      */
      {
      if((typeof completeName) != "string")
        {
        throw new Error("StringFormatException", Creator.CompleteName, {variable:"completeName", value:completeName, type:(typeof completeName)});
        }
      if(!completeName || !COMP_NAME_REG.test(completeName))
        {
        throw new Error("StringRangeException", Creator.CompleteName, {variable:"completeName", range:("NotEmpty & /"+COMP_NAME_REG.source+"/"), value:completeName});
        }
      return getPackage(completeName);
      };
    //------------------------------------------------------------------------------
    Class.getDefinition = function(completeName, searchAncestor)
     /**
      * pbP[WpbP[W`(֐)擾
      * @condition completeName͐K\COMP_NAME_REG𖞂KvB
      * @param completeName String SCpbP[W
      * @param searchAncestor [Boolean] ȂꍇɐcẽpbP[WΏۂƂ邩ǂ
      * @return Function|null ΉpbP[W`t@C̒`֐(݂Ȃꍇnull)
      * @throw StringFormatException@Error completeNamev~eBuString^łȂꍇ
      * @throw BooleanFormatException@Error searchAncestor`łv~eBuBoolean^łȂꍇ
      * @throw StringRangeException@Error completeName󕶎ł邩Aw̐K\𖞂ĂȂꍇ
      */
      {
      if((typeof completeName) != "string")
        {
        throw new Error("StringFormatException", Creator.CompleteName, {variable:"completeName", value:completeName, type:(typeof completeName)});
        }
      if((searchAncestor !== undefined) && ((typeof searchAncestor) != "boolean"))
        {
        throw new Error("BooleanFormatException", Creator.CompleteName, {variable:"searchAncestor", value:searchAncestor, type:(typeof searchAncestor)});
        }
      if(!completeName || !COMP_NAME_REG.test(completeName))
        {
        throw new Error("StringRangeException", Creator.CompleteName, {variable:"completeName", range:("NotEmpty & /"+COMP_NAME_REG.source+"/"), value:completeName});
        }
      var func = getIncludePackage(completeName, searchAncestor)
      return func;
      };
    //------------------------------------------------------------------------------
    Class.getClassNamesByDefinition = function(defineFunc)
     /**
      * pbP[W`t@C̒`֐炻̒Œ`ĂNX̃Xg擾
      * @param defineFunc Function pbP[W`t@C̒`֐
      * @return Array|null `֐̒Œ`ĂNX̃Xg(defineFunc`֐łȂꍇnull)
      * @throw FunctionFormatException@Error defineFunc֐łȂꍇ
      */
      {
      if((typeof defineFunc) != "function")
        {
        throw new Error("FunctionFormatException", Creator.CompleteName, {variable:"defineFunc", value:defineFunc, type:(typeof defineFunc)});
        }
      var classNames = null;
      var packageName = getIncludePackageName(defineFunc);
      if(packageName)
        {
        if(DefListMap[packageName])
          {
          classNames = [];
          for(var i = 0; i < DefListMap[packageName].length; i++)
            {
            classNames[i] = DefListMap[packageName][i];
            }
          }
        }
      return classNames;
      }
    
    //
    // Static - NX.StatičJoƃ\bh(p)
    //
    
    //
    // vg^Cv - NX.prototypěJoƃ\bh(p)
    //
    //------------------------------------------------------------------------------
    Proto.include = function(nestedLoading)
     /**
      * pbP[WƃNX[h
      * @explanation ̃pbP[W̒ɕێĂNXSă[hB
      * @param nestedLoading [Boolean] ñTupbP[WSă[h邩ǂB(ȗ:false)
      * @throw BooleanFormatException@Error nestedLoading`łv~eBuBoolean^łȂꍇ
      */
      {
      if((nestedLoading !== undefined) && ((typeof nestedLoading) != "boolean"))
        {
        throw new Error("BooleanFormatException", Creator.CompleteName, {variable:"nestedLoading", value:nestedLoading, type:(typeof nestedLoading)});
        }
      for(var className in this)
        {
        switch(className)
          {
          case SUPERCLASS:
          case "constructor":
            break;
          default:
            var targetClass = this[className];
            if(className && ONE_NAME_REG.test(className))
              {
              executeInclude(targetClass, className);
              }
            break;
          }
        }
      if(nestedLoading)
        {
        for(var packageName in this)
          {
          switch(packageName)
            {
            case SUPERCLASS:
            case "constructor":
              break;
            default:
              var targetPackage = this[packageName];
              if(packageName && ONE_NAME_REG.test(packageName) && ((typeof targetPackage) == "object") && (targetPackage instanceof _Package_))
                {
                targetPackage.include(nestedLoading);
                }
              break;
            }
          }
        }
      };
    
    //
    //  - NX`ɂP񂾂s
    //
    
    //##############################################################################
    //
    // RXgN^(vCx[gEthisERXgN^)
    //
    function Class()
     /**
      * PackageNX̃RXgN^
      * @notice <p>̃RXgN^gpĒ<kbd>new Package()</kbd>Ă͂ȂȂB
      *   CX^X<kbd>Package.getInstance()</kbd>\bhōsƁB</p>
      * @return js.cpt.Package 쐬ꂽpbP[W
      */
      {
      //
      // X[p[NXKp(p) - X[p[NX̃RXgN^N
      //
      //Super.apply(this, arguments);
      
      //
      // vCx[g - CX^X̔Joƃ\bh(pȂ)
      //
      
      //
      // this - CX^X̌Joƃ\bh(Kpɂp)
      //
      
      //
      // RXgN^ - CX^X̌Joƃ\bh(pȂ)
      //
      return this;
      }
    
    return Class;
    };
  
  //##############################################################################
  //
  // NX
  //
  //
  // vCx[gϐ - Joƃ\bh
  //
  //------------------------------------------------------------------------------
  function inherit(SubClass, SuperClass)
   /**
    * NXps
    * @notice ̃\bḧ͕K^`FbNς݂ł邱ƁB
    * @param SubClass Function TuNX
    * @param SuperClass [Function|null] X[p[NX
    * @explanation ̌pɂATuNXɂ͈ȉ̃IuWFNg쐬B
    *   SubClass.Super     (SuperClassւ̎Q)
    *   SubClass.Static    (SuperClass.Staticvg^CvpIuWFNg)
    *   SubClass.prototype (SuperClass.prototypevg^CvpIuWFNg)
    *   SubClass.prototype.Super     (SuperClassւ̎Q)
    *   SubClass.prototype.constructor (SubClassւ̎Q)
    */
    {
    if(SuperClass)
      {
      // NXo쐬
      SubClass[SUPERCLASS] = SuperClass;
      // Staticop
      var Temp       = function(){};
      Temp.prototype = SuperClass[EXTENSIONS];
      var Static     = new Temp();
      SubClass[EXTENSIONS] = Static;
      // vg^Cvp
      var Func       = function(){};
      Func.prototype = SuperClass.prototype;
      var Proto      = new Func();
      Proto[SUPERCLASS]    = SuperClass;
      Proto.constructor    = SubClass;
      SubClass.prototype   = Proto;
      }
    else
      {
      SubClass[SUPERCLASS] = NATIVE_OBJECT;
      SubClass[EXTENSIONS] = {};
      SubClass.prototype[SUPERCLASS] = NATIVE_OBJECT;
      }
    }
  
  //------------------------------------------------------------------------------
  function participate(SubClass, Interfaces)
   /**
    * C^[tF[X
    * @notice ydvzKpsŎs邱ƁB
    * @notice ̃\bḧ͕K^`FbNς݂ł邱ƁB
    * @param SubClass Function TuNX
    * @param Interfaces [Array|null] C^[tF[X(Function^)̃Xg
    * @explanation ̎ɂATuNXɈȉ̃IuWFNg쐬B
    *   SubClass.Interfaces        (C^[tF[X̃Xg)
    *   SubClass.Static.Interfaces (pꂽC^[tF[X̃Xg)
    */
    {
    // ^̕ϊ
    var tranceformer = function()
      {
      arguments.hasInterface = function(Interface)
        {
        for(var i = 0; i < this.length; i++)
          {
          if(this[i] == Interface)
            {
            return true;
            }
          }
        return false;
        };
      return arguments;
      };
    // NXoɒǉ
    if(!Interfaces)
      {
      Interfaces = [];
      }
    Interfaces = tranceformer.apply(null, Interfaces);
    SubClass[INTERFACES] = Interfaces;
    // C^[tF[Xp
    var SuperClass      = SubClass[SUPERCLASS];
    var SuperStatic     = SuperClass ? SuperClass[EXTENSIONS] : null;
    var SuperInterfaces = SuperStatic ? SuperStatic[INTERFACES] : (SuperClass ? SuperClass[INTERFACES] : null);
    var InterfaceList   = [];
    if(SuperInterfaces && ((typeof SuperInterfaces) == "object") && ((typeof SuperInterfaces.length) == "number"))
      {
      for(var i = 0; i < SuperInterfaces.length; i++)
        {
        InterfaceList[i] = SuperInterfaces[i];
        }
      }
    for(var i = 0; i < Interfaces.length; i++)
      {
      InterfaceList[InterfaceList.length] = Interfaces[i];
      }
    InterfaceList = tranceformer.apply(null, InterfaceList);
    SubClass[EXTENSIONS][INTERFACES] = InterfaceList;
    }
  
  //------------------------------------------------------------------------------
  function create(Super, Interfaces)
   /**
    * NX̍쐬ƃ`FbNs
    * @notice ̃\bḧthis͕K^`FbNς݂ł邱ƁB
    * @this Function NG[^[֐
    * @param Super [Function|null] X[p[NX
    * @param Interfaces [Array|null] C^[tF[X(Function^)Xg
    * @return Function NX
    * @throw SystemError@Error NXłȂiNG[^[֐̖߂l֐ł͂Ȃjꍇ
    * @throw SystemError@Error NXłȂiNG[^[֐inherit\bhsĂȂjꍇ
    * @throw SystemError@Error NXłȂiC^[tF[X`̎`FbNG[jꍇ
    */
    {
    
    // NXNG[^[
    var Creator = this;
    
    // X[p[NX(w)
    var SuperClass = Super ? Super : null;
    // X[p[NX()
    var CreatorSuper = SuperClass ? SuperClass : NATIVE_OBJECT;
    
    // ptO
    var isInherited = false;
    // pG[
    var inheritError = false;
    
    // p\bh̎
    Creator.inherit = function(Class, Super)
     /**
      * NXp
      * @notice ̃\bh̓NX쐬ɕKPsȂ΂ȂȂB
      * @param Class Function p̃TuNX
      * @param Super [Function|null] p̃X[p[NX
      * @throw SystemError@Error ̃\bh𕡐sꍇ
      * @throw FunctionFormatException@Error Class֐łȂꍇ
      * @thorw FunctionFormatException@Error Supernullł`ł֐łȂꍇ
      * @throw RangeException@Error X[p[NXs̏ꍇ
      */
      {
      inheritError = true;
      if(isInherited)
        {
        throw new Error("SystemError", "inherit\bh͕sł܂B" + Creator.CompleteName);
        }
      isInherited = true;
      if((typeof Class) != "function")
        {
        throw new Error("FunctionFormatException", {varidate:"Class", value:Class, type:(typeof Class), message:("inherit\bḧClass֐ł͂܂B" + Creator.CompleteName), toString:(function(){return this.message;})});
        }
      if((Super != null) && (Super !== undefined) && ((typeof Super) != "function"))
        {
        throw new Error("FunctionFormatException", {varidate:"Super", value:Super, type:(typeof Super), message:("inherit\bḧSupernullł`ł֐ł͂܂B" + Creator.CompleteName), toString:(function(){return this.message;})});
        }
      else if(Super != CreatorSuper)
        {
        throw new Error("RangeException", "inhreit\bḧSuper̒lNG[^[֐̑PƈقȂ܂B" + Creator.CompleteName);
        }
      inherit(Class, SuperClass);
      participate(Class, Interfaces);
      inheritError = false;
      };
    
    // NX
    var Class = Creator(CreatorSuper);
    
    // p\bh̍폜
    delete Creator.inherit;
    
    // NX`FbN
    if((typeof Class) != "function")
      {
      throw new Error("SystemError", "NG[^[֐̖߂l֐łȂ߁ANX܂łB" + Creator.CompleteName);
      }
    
    // p`FbN
    if(!isInherited || inheritError)
      {
      throw new Error("SystemError", "NG[^[֐inherit\bhsȂ߁ANXp܂łB" + Creator.CompleteName);
      }
    
    // C^[tF[X`FbN\bh̎
    Creator.isImplemented = function(Class, Interface)
     /**
      * C^[tF[XĂ邩`FbNs
      * @param Class Function `FbNΏۂ̃NX
      * @param Interface Function C^[tF[X
      * @return Boolean Ă邩ǂ
      */
      {
      // NXo
      for(var i in Interface)
        {
        switch(i)
          {
          case SUPERCLASS:
          case EXTENSIONS:
          case INTERFACES:
          case PACKAGEOBJ:
          case "prototype":
            break;
          default:
            if((Interface[i] !== undefined) && (Class[i] === undefined))
              {
              return false;
              }
            break;
          }
        }
      // Statico
      if(Interface[EXTENSIONS])
        {
        for(var i in Interface[EXTENSIONS])
          {
          switch(i)
            {
            case INTERFACES:
            case "prototype":
              break;
            default:
              if((Interface[EXTENSIONS][i] !== undefined) && (Class[EXTENSIONS][i] === undefined))
                {
                return false;
                }
              break;
            }
          }
        }
      // prototypeo
      for(var i in Interface.prototype)
        {
        switch(i)
          {
          case SUPERCLASS:
          case "constructor":
            break;
          default:
            if((Interface.prototype[i] !== undefined) && (Class.prototype[i] === undefined))
              {
              return false;
              }
            break;
          }
        }
      return true;
      };
    
    // C^[tF[X`FbNs
    var isImplemented = true;
    if(Interfaces)
      {
      for(var i = 0; i < Interfaces.length; i++)
        {
        if(!Creator.isImplemented(Class, Interfaces[i]))
          {
          isImplemented = false;
          break;
          }
        }
      }
    
    // C^[tF[X`FbN\bh̍폜
    delete Creator.isImplemented;
    
    // C^[tF[X`FbN
    if(!isImplemented)
      {
      throw new Error("SystemError", "C^[tF[XĂ܂B" + Creator.CompleteName);
      }
    
    return Class;
    }
  
  //------------------------------------------------------------------------------
  function createToString(Class, completeName)
   /**
    * NXtoString\bhI[o[Ch
    * @notice ̃\bḧ͕K^`FbNς݂ł邱ƁB
    * @param Class Function ΏۃNX
    * @param completeName String SCNX
    */
    {
    var nativeToString = Class.toString;
    Class.toString = function(Class)
     /**
      * NX̕\擾
      * @notice NX̂łȂꍇ́AlCeButoStringsB
      * @param Class [Function|Variant] NX
      * @return String NX̕\
      */
      {
      if(Class == this)
        {
        return completeName;
        }
      else
        {
        return nativeToString.apply(this, arguments);
        }
      };
    }
  
  //
  // ClassNX
  //
  //------------------------------------------------------------------------------
  var ClassCreator = function(Super)
   /**
    * uNXvNX
    * @param Super [Function|null] X[p[NX
    * @return Function js.cpt.ClassNX
    * 
    * @package js.cpt
    * @update 2007/03/10
    * @version 2.03.04
    * @author Mug
    * @copyright (C) 2005-2007 Mug, All rights reserved.
    * 
    * @explanation <p>̃NXCPT(ClassPackagingTool)̃NXCX^X𐶐ƂɎgpB<br />
    *   NXCX^XƂ́ANXt@Cǂݍލۂ̏`̂łB
    *   ɂ́ANXCˑNXCCN[h̃IvV̂Rނ̏`ĂB</p>
    *   <p>ˑNXƂ́ÃNXɂ͕KKvȃNXŁAɃCN[hĂNXƂȂB
    *   ˑNX`ĂƂŁAIɂ̃NXɃCN[h邱ƂłB</p>
    * @example <p>CN[hNXt@C̒ł̃NX̒`͈ȉ̂悤ɍsBij<br />
    *   com.sample.test.ElementManagerNXpcom.sample.test.form.TextBoxManagerNX`ꍇB</p>
    *   <pre><code>
    *   Class.create(function(Super) {
    *     
    *     // NG[^[֐
    *     var Creator = arguments.callee;
    *     // SCNX
    *     Creator.ComplateName = "com.sample.test.form.TextBoxManager";
    *     
    *     // p
    *     Creator.inherit(Class, Super);
    *     // StaticIuWFNg
    *     var Static = Class.Static;
    *     
    *     // Class,Static,Class.prototypeɑ΂ݒȂǂLq
    *     
    *     // RXgN^
    *     function Class() {
    *       Super.apply(this, arguments);
    *       
    *       // thisɑ΂ݒȂǂLq
    *       
    *       return this;
    *     }
    *     return Class;
    *   }, com.sample.test.ElementManager);
    *   </code></pre>
    * @rel js.cpt.Package
    */
    {
    //##############################################################################
    //
    // wb_(vpeBEpENXpX)
    //
    //
    // vpeB - NXɊւ郁^f[^
    //
    //:V Creator Function NXNG[^[
    var Creator = arguments.callee;
    // SCNX
    Creator.CompleteName = (ROOT_PACKAGE_NAME + ".Class");
    
    //
    // p - vg^CvpƊ{õZbg
    //
    // p
    Creator.inherit(Class, Super);
    //:V Static Object StaticIuWFNg
    var Static = Class.Static;
    //:V Proto Object vg^Cv
    var Proto = Class.prototype;
    
    //
    // NXpX
    //
    
    //##############################################################################
    //
    // {fB(vCx[gENXEStaticEvg^CvE)
    //
    //
    // vCx[g - NX̔Joƃ\bh(pȂ)
    //
    
    //
    // NX - NX̌Joƃ\bh(pȂ)
    //
    //------------------------------------------------------------------------------
    Class.create = function(Creator, SuperClass)
     /**
      * ClassNX̃RXgN^
      * @param Creator Function NX쐬֐
      * @param SuperClass [Function|null] X[p[NX
      * @params [Function] C^[tF[X
      * @return Function 쐬ꂽNX
      * @throw FunctionFormatException@Error Creator֐łȂꍇ
      * @throw FunctionFormatException@Error SuperClassnullł`ł֐łȂꍇ
      * @throw FunctionFormatException@Error Rȍ~̈iC^[tF[XjɊ֐ȊOnꂽꍇ
      * @explanation <p>NXpbP[Wc[(ClassPackagingTool)ɂgNXhƂ́A
      *   ECMAScriptgݍ݊֐łFunction֐̃CX^XłBi܂gNXh͊֐j
      *   ܂ʏ́AP́gNXh͂P̃t@Cɍ쐬B</p>
      *   <p>ClassNX̃CX^X́gNXhł͂ȂgNX`hłA
      *   gNXhLqĂt@Cǂݍނ߂ɕKvȏێĂB
      *   ClassNX̃CX^X́ApbP[W`t@C̓ōsB</p>
      */
      {
      // `FbN
      if((typeof Creator) != "function")
        {
        throw new Error("FunctionFormatException", ClassCreator.CompleteName, {variable:"Creator", value:Creator, type:(typeof Creator)});
        }
      if((SuperClass != null) && (SuperClass !== undefined) && ((typeof SuperClass) != "function"))
        {
        throw new Error("FunctionFormatException", ClassCreator.CompleteName, {variable:"SuperClass", value:SuperClass, type:(typeof SuperClass)});
        }
      var Interfaces = null;
      if(arguments.length > 2)
        {
        Interfaces = [];
        for(var i = 2; i < arguments.length; i++)
          {
          var aInterface = arguments[i];
          if((typeof aInterface) != "function")
            {
            throw new Error("FunctionFormatException", ClassCreator.CompleteName, {variable:("arguments["+i+"]"), value:aInterface, type:(typeof aInterface)});
            }
          Interfaces[Interfaces.length] = aInterface;
          }
        }
      // NX
      var NewClass = create.call(Creator, SuperClass, Interfaces);
      // pbP[Wo^
      if((typeof Creator.CompleteName) == "string")
        {
        regist(NewClass, Creator.CompleteName);
        }
      // toStringI[o[Ch
      createToString(NewClass, Creator.CompleteName);
      // NG[^[ۑ
      setCreator(Creator.CompleteName, Creator);
      // m
      return NewClass;
      };
    //------------------------------------------------------------------------------
    Class.setClassLoader = function(loaderMethod)
     /**
      * NX[_[ݒ肷
      * @notice ̃\bh͂P񂵂gƂ͂łȂB
      * @param loaderMethod Function NX[_[
      * @explanation NX[_[́Ajs.cpt.ClassIuWFNgthisƂĎsAłȂ񕜕s\ȃG[Ƃ̂݃X[֐ł邱ƁB
      * @throw FunctionFormatException@Error loaderMethod֐łȂꍇ
      * @throw SystemError@Error ̃\bhsꂽꍇ
      */
      {
      if((typeof loaderMethod) != "function")
        {
        throw new Error("FunctionFormatException", Creator.CompleteName, {variable:"loaderMethod", value:loaderMethod, type:(typeof loaderMethod)});
        }
      if(ClassLoader)
        {
        throw new Error("SystemError", Creator.CompleteName, "js.cpt.Class.setClassLoader\bh͕sł܂B");
        }
      ClassLoader = loaderMethod;
      // \bh폜
      delete Class.setClassLoader;
      };
    //------------------------------------------------------------------------------
    Class.getCreator = function(completeName)
     /**
      * SCNXNG[^[擾
      * @param completeName  String SCNX
      * @return Function|null ΉNX̃NG[^[
      * @throw StringFormatException@Error completeNamev~eBuString^łȂꍇ
      * @throw StringRangeException@Error completeName󕶎ꍇ
      */
      {
      if((typeof completeName) != "string")
        {
        throw new Error("StringFormatException", Creator.CompleteName, {variable:"completeName", value:completeName, type:(typeof completeName)});
        }
      if(!completeName)
        {
        throw new Error("StringRangeException", Creator.CompleteName, {variable:"completeName", range:"NotEmpty", value:completeName});
        }
      return getCreator(completeName);
      };
    //------------------------------------------------------------------------------
    Class.getClass = function(completeName, isReady)
     /**
      * SCNXNX擾
      * @param completeName String SCNX
      * @param isReady Boolean Ă邩ǂ(Ƃ̓NXt@Cǂݍ܂AcreateApbP[Wo^Ă邩ǂ)
      * @return Function|js.cpt.Class|null ΉNX
      * @throw StringFormatException@Error completeNamev~eBuString^łȂꍇ
      * @throw StringRangeException@Error completeName󕶎ł邩AK\COMP_NAME_REG𖞂Ȃꍇ
      * @throw BooleanFormatException@Error isReadyv~eBuBoolean^łȂꍇ
      */
      {
      if((typeof completeName) != "string")
        {
        throw new Error("StringFormatException", Creator.CompleteName, {variable:"completeName", value:completeName, type:(typeof completeName)});
        }
      if(!completeName || !COMP_NAME_REG.test(completeName))
        {
        throw new Error("StringRangeException", Creator.CompleteName, {variable:"completeName", range:("NotEmpty & /"+COMP_NAME_REG.source+"/"), value:completeName});
        }
      if((typeof isReady) != "boolean")
        {
        throw new Error("BooleanFormatException", Creator.CompleteName, {variable:"isReady", value:isReady, type:(typeof isReady)});
        }
      var nameList = completeName.split(".");
      var className   = nameList[nameList.length - 1];
      var packageName = null;
      if(nameList.length > 1)
        {
        packageName = completeName.substring(0, (completeName.length - 1 - className.length));
        }
      var basePackage = getPackage(packageName, false);
      var target = basePackage ? basePackage[className] : null;
      // Ώۂ擾łȂꍇ
      if((target == null) || (target === undefined))
        {
        return null;
        }
      // ς݂̃NX
      else if(isReady && target && ((typeof target) == "function"))
        {
        return target;
        }
      // ÕNX
      else if(!isReady && target && ((typeof target) == "object") && (target instanceof _Class_))
        {
        return target;
        }
      // Ȃꍇ
      else
        {
        return null;
        }
      };
    //------------------------------------------------------------------------------
    Class.getDefinition = function(completeName)
     /**
      * SCNXNX`擾
      * @param completeName String SCNX
      * @return js.cpt.Class|null ΉNX`
      * @throw StringFormatException@Error completeNamev~eBuString^łȂꍇ
      * @throw StringRangeException@Error completeName󕶎ł邩AK\COMP_NAME_REG𖞂Ȃꍇ
      */
      {
      if((typeof completeName) != "string")
        {
        throw new Error("StringFormatException", Creator.CompleteName, {variable:"completeName", value:completeName, type:(typeof completeName)});
        }
      if(!completeName || !COMP_NAME_REG.test(completeName))
        {
        throw new Error("StringRangeException", Creator.CompleteName, {variable:"completeName", range:("NotEmpty & /"+COMP_NAME_REG.source+"/"), value:completeName});
        }
      var define = DefineMap[completeName];
      if(define && ((typeof define) == "object") && (define instanceof _Class_))
        {
        return define;
        }
      else
        {
        return Class.getClass(completeName, false);
        }
      };
    
    //
    // Static - NX.StatičJoƃ\bh(p)
    //
    
    //
    // vg^Cv - NX.prototypěJoƃ\bh(p)
    //
    
    //
    //  - NX`ɂP񂾂s
    //
    
    //##############################################################################
    //
    // RXgN^(vCx[gEthisERXgN^)
    //
    function Class(name, reliances, options)
     /**
      * ClassNX̃RXgN^iVNX`쐬j
      * @explanation ̃NXƃCX^X̓NX[_[ƂĂ@\B
      *   CX^Xload\bhsƃNX[hB
      *   CX^Xload\bh͎sƂɃI[o[ChĎB
      * @param name String NX
      * @param reliances [Array|null] ˑ̊SCNX(String^)̃Xg
      * @param options [String] [hɓKpIvV(sƂɈقȂ)
      * @return js.cpt.Class NXIuWFNg
      * @throw StringFormatException@Error namev~eBuString^łȂꍇ
      * @throw StringRangeException@Error name󕶎ł邩AK\ONE_NAME_REG𖞂Ȃꍇ
      * @throw FormatException@Error reliancesnullł`łArray^łȂꍇ
      * @throw StringFormatException@Error optionsnullł`łv~eBuString^łȂꍇ
      * @throw StringFormatException@Error reliancesɎ̂ƂA̗vfPłv~eBuString^łȂꍇ
      * @throw StringRangeException@Error reliancesɎ̂ƂA̗vfPł󕶎ł邩AK\INCLUDE_NAME_REG𖞂Ȃꍇ
      */
      {
      //
      // X[p[NXKp(p) - X[p[NX̃RXgN^N
      //
      //Super.apply(this, arguments);
      
      //
      // vCx[g - CX^X̔Joƃ\bh(pȂ)
      //
      //:v _name String|null NX
      var _name = null;
      //:v _reliances Array|null ˑ̊SCNX̃Xg
      var _reliances = null;
      //:v _options String|null IvV
      var _options = null;
      
      //
      // this - CX^X̌Joƃ\bh(Kpɂp)
      //
      //:i isReady Boolean sꂽǂ
      this.isReady = false;
      // Ăяo֐̕ۑie|j
      this[INCLUDE_PACKAGE] = arguments.callee.caller;
      
      //------------------------------------------------------------------------------
      this.getName = function()
       /**
        * NX擾
        * @return String NX
        */
        {
        return _name;
        };
      //------------------------------------------------------------------------------
      this.getReliances = function()
       /**
        * ˑ̊SCNX̃Xg擾
        * @return Array|null ˑ̊SCNX̃Xg
        * @explanation Ŏ擾ł郊Xg͕łAeύXĂe͏oȂB
        */
        {
        if(_reliances)
          {
          var list = [];
          for(var i = 0; i < _reliances.length; i++)
            {
            list[list.length] = _reliances[i];
            }
          return list;
          }
        else
          {
          return _reliances;
          }
        };
      //------------------------------------------------------------------------------
      this.getOptions = function()
       /**
        * IvV擾
        * @return String IvV
        */
        {
        return _options;
        };
      
      //
      // RXgN^ - CX^X̌Joƃ\bh(pȂ)
      //
      if((typeof name) != "string")
        {
        throw new Error("StringFormatException", Creator.CompleteName, {variable:"name", value:name, type:(typeof name)});
        }
      if(!name || !ONE_NAME_REG.test(name))
        {
        throw new Error("StringRangeException", Creator.CompleteName, {variable:"name", range:("NotEmpty & /"+ONE_NAME_REG.source+"/"), value:name});
        }
      if((reliances != null) && (reliances !== undefined) && !(reliances && ((typeof reliances) == "object") && (reliances instanceof Array)))
        {
        throw new Error("FormatException", Creator.CompleteName, {variable:"reliances", format:"[Array|null]", value:reliances, type:(typeof reliances)});
        }
      if((options != null) && (options !== undefined) && ((typeof options) != "string"))
        {
        throw new Error("StringFormatException", Creator.CompleteName, {variable:"options", value:options, type:(typeof options)});
        }
      _name = name;
      if(reliances)
        {
        _reliances = [];
        for(var i = 0; i < reliances.length; i++)
          {
          if((typeof reliances[i]) != "string")
            {
            throw new Error("StringFormatException", Creator.CompleteName, {variable:("reliance["+i+"]"), value:reliances[i], type:(typeof reliances[i])});
            }
          if(!reliances[i] || !INCLUDE_NAME_REG.test(reliances[i]))
            {
            throw new Error("StringRangeException", Creator.CompleteName, {variable:("reliance["+i+"]"), range:("NotEmpty & /"+INCLUDE_NAME_REG.source+"/"), value:reliances[i]});
            }
          _reliances[_reliances.length] = reliances[i];
          }
        }
      if(options)
        {
        _options = options;
        }
      return this;
      }
    
    return Class;
    };
  
  //##############################################################################
  //
  // O[o
  //
  //
  // vCx[gϐ - Joƃ\bh
  //
  //------------------------------------------------------------------------------
  function globalDefine(name, value)
   /**
    * O[oIuWFNgɕϐ`ǉ
    * @notice ̃\bḧ͕K^`FbNς݂ł邱ƁB
    * @param name String ϐ
    * @param value [Variant] l
    */
    {
    GLOBAL_OBJ[name] = value;
    };
  
  //------------------------------------------------------------------------------
  function globalize(Class, className, replacing)
   /**
    * NXO[o
    * @notice ̃\bḧ͕K^`FbNς݂ł邱ƁB
    * @condition ̃NX̓pbP[Wo^ς݂ł邱ƁB
    * @param Class Function O[oNX
    * @param className String O[oϐ
    * @param replacing [Boolean] قȂNXŊɃO[oĂƂɌ邩ǂ(ȗ:false)
    * @return Boolean O[oɐǂ
    */
    {
    var isSuccess = false;
    var oldObj = GLOBAL_OBJ[className];
    // qȂꍇ
    if(oldObj === undefined)
      {
      globalDefine(className, Class);
      isSuccess = true;
      }
    // ɃO[oς݂̏ꍇ
    else if(oldObj == Class)
      {
      isSuccess = true;
      }
    // قȂNXO[oς݂̏ꍇ
    else if(((typeof oldObj) == "function") && oldObj[PACKAGEOBJ] && ((typeof oldObj[PACKAGEOBJ]) == "object") && (oldObj[PACKAGEOBJ] instanceof _Package_))
      {
      if(replacing)
        {
        globalDefine(className, Class);
        isSuccess = true;
        }
      else
        {
        isSuccess = false;
        }
      }
    // ֌WȂIuWFNg݂ꍇ
    else
      {
      isSuccess = false;
      }
    return isSuccess;
    }
  
  //##############################################################################
  //
  // CN[h
  //
  //
  // vCx[gϐ - Joƃ\bh
  //
  //------------------------------------------------------------------------------
  function executeInclude(Class, className)
   /**
    * NX̃CN[hs
    * @notice ̃\bḧ͕K^`FbNς݂łȂ΂ȂȂB
    * @param Class js.cpt.Class|Function CN[hΏۃNX
    * @param className String NX
    * @return Boolean CN[hǂ
    * @throw SystemError@Error t@C̃[hɃG[ꍇ
    */
    {
    var isSuccess = false;
    // js.cpt.ClassIuWFNg̏ꍇ
    if(Class && ((typeof Class) == "object") && (Class instanceof _Class_))
      {
      // sς݂̏ꍇ
      if(Class.isReady)
        {
        isSuccess = true;
        }
      // ̏ꍇ
      else
        {
        Class.isReady = true;
        // ˑ̏mF
        var reliances = Class.getReliances();
        if(reliances)
          {
          for(var i = 0; i < reliances.length; i++)
            {
            try
              {
              _include_(reliances[i], false);
              }
            catch(e)
              {
              Class.isReady = false;
              throw e;
              }
            }
          }
        // s
        try
          {
          if(ClassLoader)
            {
            ClassLoader.call(Class);
            }
          }
        catch(e)
          {
          isSuccess = false;
          throw new Error("SystemError", "t@C̃[hsɃG[܂B" + className);
          }
        isSuccess = true;
        }
      }
    // 쐬ς݂̃NX̏ꍇ
    else if(Class && ((typeof Class) == "function"))
      {
      //globalize(Class, className, false);
      isSuccess = true;
      }
    // ClassΏۊȌꍇ
    else
      {
      isSuccess = false;
      }
    return isSuccess;
    }
  
  //------------------------------------------------------------------------------
  function _include_(completeName, nestedInclude)
   /**
    * NXCN[h
    * @explanation NX*(AX^XN)gp邱ƂłB
    * @param completeName String SCNX
    * @param nestedInclude [Boolean] lXgčċAIɃCN[h邩ǂ(ȗ:false)
    * @throw StringFormatException@Error completeNamev~eBuString^łȂꍇ
    * @throw StringRangeException@Error completeName󕶎ł邩AK\INCLUDE_NAME_REG𖞂ĂȂꍇ
    * @throw BooleanFormatException@Error nestedInclude`łv~eBuBoolean^łȂꍇ
    * @throw SystemError@Error ݂ȂpbP[WCN[h悤Ƃꍇ
    * @throw SystemError@Error NXłȂ̂CN[h悤Ƃꍇ
    */
    {
    if((typeof completeName) != "string")
      {
      throw new Error("StringFormatException", {variable:"completeName", value:completeName, type:(typeof completeName), message:("include\bḧcompleteNamev~eBuString^ł͂܂BcompleteName=" + completeName), toString:(function(){return this.message;})});
      }
    if(!completeName || !INCLUDE_NAME_REG.test(completeName))
      {
      throw new Error("StringRangeException", {variable:"completeName", range:("NotEmpty & /"+INCLUDE_NAME_REG.source+"/"), value:completeName, message:("include\bḧcompleteName󕶎ł邩AK\/" + INCLUDE_NAME_REG.source + "/𖞂Ă܂BcompleteName=" + completeName), toString:(function(){return this.message;})});
      }
    if((nestedInclude !== undefined) && ((typeof nestedInclude) != "boolean"))
      {
      throw new Error("BooleanFormatException", {variable:"nestedInclude", value:nestedInclude, type:(typeof nestedInclude), message:("include\bḧnestedInclude`łv~eBuBoolean^ł܂BnestedInclude=" + nestedInclude), toString:(function(){return this.message;})});
      }
    var nameList = completeName.split(".");
    var className = nameList[nameList.length - 1];
    var packageName = completeName.substring(0, (completeName.length - 1 - className.length));
    var packageObj  = getPackage(packageName);
    if(!packageObj)
      {
      throw new Error("SystemError", "݂ȂpbP[WCN[h悤Ƃ܂B" + packageName);
      }
    // pbP[W̃CN[h(ChJ[hgp)
    if(className == "*")
      {
      packageObj.include(nestedInclude);
      }
    // NX̃CN[h
    else
      {
      var targetClass = packageObj[className];
      if(!executeInclude(targetClass, className))
        {
        throw new Error("SystemError", "NXł͂Ȃ̂̓CN[hł܂B" + className);
        }
      }
    }
  
  //##############################################################################
  //
  // pbP[W`t@C
  //
  //
  // vCx[gϐ - Joƃ\bh
  //
  //------------------------------------------------------------------------------
  function registIncludePackage(defineFunc, packageName)
   /**
    * pbP[W`t@C̒`֐o^
    * @param defineFunc Function|null pbP[W`t@C̒`֐
    * @param packageName String SCpbP[W(pbP[W`ʒu)
    */
    {
    var check = false;
    if(((typeof defineFunc) == "function") && packageName && ((typeof packageName) == "string"))
      {
      if(PackageMap[packageName] == defineFunc)
        {
        check = true;
        }
      else if(PackageMap[packageName])
        {
        check = false;
        }
      else
        {
        check = true;
        var registedName = null;
        for(var i in PackageMap)
          {
          if(defineFunc == PackageMap[i])
            {
            registedName = i;
            break;
            }
          }
        if(registedName)
          {
          if(registedName == packageName)
            {
            check = true;
            }
          else if(packageName.indexOf((registedName + "."), 0) == 0)
            {
            check = true;
            }
          else if(registedName.indexOf((packageName + "."), 0) == 0)
            {
            PackageMap[packageName] = PackageMap[registedName];
            DefListMap[packageName] = DefListMap[registedName];
            delete PackageMap[registedName];
            delete DefListMap[registedName];
            check = true;
            }
          else
            {
            PackageMap[packageName] = defineFunc;
            DefListMap[packageName] = DefListMap[registedName];  // Xg͋L
            check = false;
            }
          }
        else
          {
          PackageMap[packageName] = defineFunc;
          DefListMap[packageName] = [];
          check = true;
          }
        // ꏉ(js.cpt̏쐬js.cpt.Package,js.cpt.Classǉ)
        if(packageName == ROOT_PACKAGE_NAME)
          {
          DefListMap[packageName][DefListMap[packageName].length] = ROOT_PACKAGE_NAME + ".Package";
          DefListMap[packageName][DefListMap[packageName].length] = ROOT_PACKAGE_NAME + ".Class";
          }
        }
      }
    return check;
    }
  
  //------------------------------------------------------------------------------
  function getIncludePackage(packageName, searchAncestor)
   /**
    * pbP[W`t@C̒`֐擾
    * @param packageName String SCpbP[W(pbP[W`ʒu)
    * @param searchAncestor [Boolean] pbP[W[gɌ邩ǂ
    * @return Function|null pbP[W`t@C̒`֐
    */
    {
    var func = null;
    var list = [];
    for(var i in PackageMap)
      {
      if(i == packageName)
        {
        func = PackageMap[i];
        break;
        }
      else
        {
        list[list.length] = i;
        }
      }
    if(!func && searchAncestor)
      {
      var ancestor = null;
      for(var i = 0; i < list.length; i++)
        {
        if(packageName.indexOf((list[i] + "."), 0) == 0)
          {
          if(!ancestor || (ancestor.length < list[i].length))
            {
            ancestor = list[i];
            }
          }
        }
      if(ancestor)
        {
        func = PackageMap[ancestor];
        }
      }
    return func;
    }
  
  //------------------------------------------------------------------------------
  function getIncludePackageName(defineFunc)
   /**
    * pbP[W`֐pbP[W`ʒu擾
    * @param defineFunc Function pbP[W`֐
    * @return String|null pbP[W`ʒu
    */
    {
    var packageName = null;
    if(defineFunc && ((typeof defineFunc) == "function"))
      {
      for(var i in PackageMap)
        {
        if(PackageMap[i] == defineFunc)
          {
          packageName = i;
          break;
          }
        }
      }
    return packageName;
    }
  
  //------------------------------------------------------------------------------
  function addDefinedClass(defineFunc, completeName)
   /**
    * pbP[W`XgɃNX
    * @param defineFunc Function pbP[W`֐
    * @param completeName String SCNX
    */
    {
    var packageName = getIncludePackageName(defineFunc);
    if(packageName)
      {
      var classNames = DefListMap[packageName];
      if(classNames)
        {
        classNames[classNames.length] = completeName;
        }
      }
    }
  
  //##############################################################################
  //
  // NG[^[
  //
  //
  // vCx[gϐ - Joƃ\bh
  //
  //------------------------------------------------------------------------------
  function setCreator(CompleteName, Creator)
   /**
    * NG[^[SCNXŕۑ
    * @param CompleteName String SCNX
    * @param Creator Function NXNG[^[
    */
    {
    CreatorMap[CompleteName] = Creator;
    }
  
  //------------------------------------------------------------------------------
  function getCreator(CompleteName)
   /**
    * NG[^[SCNXŎ擾
    * @param CompleteName String SCNX
    * @return Function|null NXNG[^[
    */
    {
    var Creator = CreatorMap[CompleteName];
    if(!Creator)
      {
      Creator = null;
      }
    return Creator;
    }
  
  //##############################################################################
  //
  // Ss
  //
  //
  // pbP[W֘A
  //
  // PackageNX()̐
  //:V _Package_ Function PackageNX()
  var _Package_ = create.call(PackageCreator);
  // PackageNX̓o^
  regist(_Package_, PackageCreator.CompleteName);
  // toString̃I[o[Ch
  createToString(_Package_, PackageCreator.CompleteName);
  // NG[^[̕ۑ
  setCreator(PackageCreator.CompleteName, PackageCreator);
  // O[oIuWFNgɃRs[
  Package = _Package_;
  //globalDefine("Package", _Package_);
  
  //
  // NX֘A
  //
  // ClassNX()̐
  //:V _Class_ Function ClassNX()
  var _Class_ = create.call(ClassCreator);
  // ClassNX̓o^
  regist(_Class_, ClassCreator.CompleteName);
  // toString̃I[o[Ch
  createToString(_Class_, ClassCreator.CompleteName);
  // NG[^[̕ۑ
  setCreator(ClassCreator.CompleteName, ClassCreator);
  // O[oIuWFNgɃRs[
  Class = _Class_;
  //globalDefine("Class", _Class_);
  
  //
  // NX`ォǉ
  //
  // js.cpt.PackageNX
  DefineMap[PackageCreator.CompleteName] = new Class("Package",
    null,
    "extension=.js,type=text/javascript,charset=Shift_JIS"
    );
  DefineMap[PackageCreator.CompleteName].isReady = true;
  delete DefineMap[PackageCreator.CompleteName][INCLUDE_PACKAGE];
  // js.cpt.ClassNX
  DefineMap[ClassCreator.CompleteName] = new Class("Class",
    [PackageCreator.CompleteName],
    "extension=.js,type=text/javascript,charset=Shift_JIS"
    );
  DefineMap[ClassCreator.CompleteName].isReady = true;
  delete DefineMap[ClassCreator.CompleteName][INCLUDE_PACKAGE];
  
  //
  // O[o֘A
  //
  // O[oIuWFNginclude\bh
  include = _include_;
  //globalDefine("include", _include_);
  
  //------------------------------------------------------------------------------
  // O[oIuWFNgglobalize\bh
  globalDefine("globalize", function(completeName, replacing)
   /**
    * NXO[o
    * @condition ̃NX̓pbP[Wo^ς݂ł邱ƁB
    * @param completeName String SCNX
    * @param replacing [Boolean] قȂNXŊɃO[oĂƂɌ邩ǂ(ȗ:false)
    * @return Boolean O[oɐǂ
    * @throw BooleanFormatException@Error replacing`łv~eBuBoolean^łȂꍇ
    * @throw SystemError ݂ȂNXO[o悤Ƃꍇ
    */
    {
    if((replacing !== undefined) && ((typeof replacing) != "boolean"))
      {
      throw new Error("BooleanFormatException", {variable:"replacing", value:replacing, type:(typeof replacing), message:("globalDefine\bḧreplacing`łv~eBuBoolean^ł܂Breplacing=" + replacing), toString:(function(){return this.message;})});
      }
    var classObj = _Class_.getClass(completeName, true);
    if(!classObj)
      {
      throw new Error("SystemError", "݂ȂNXO[o悤Ƃ܂B" + completeName);
      }
    var nameList = completeName.split(".");
    var className = nameList[nameList.length - 1];
    return globalize(classObj, className, replacing);
    });
  
  }
)();

/******************************************************************************/

(function()
 /**
  * NXpbP[Wc[
  * 
  * @name ClassPackagingTool
  * @package js.cpt
  * @update 2006/02/24
  * @version 1.00.00
  * @author Mug
  * @copyright (C) 2006 Mug, All rights reserved.
  * 
  * @explanation <p>̃pbP[ẂuNXpbP[Wc[(ClassPackagingTool)vgōŒKvȃNX`ĂB
  *   PackageNXClassNX̓ftHgŃNXǂݍ܂ĩt@CɊ܂܂jAȊÕNXincludeKvłB</p>
  */
  {
  //------------------------------------------------------------------------------
  // NXpX
  
  //:V Package Function js.cpt.PackageNX
  var Package = js.cpt.Package;
  
  //:V Class Function js.cpt.ClassNX
  var Class = js.cpt.Class;
  
  //------------------------------------------------------------------------------
  // pbP[W
  
  //:V cpt js.cpt.Package JSDpbP[W
  var cpt = Package.getInstance("js.cpt");
  
  //------------------------------------------------------------------------------
  // NX`
  
  //:I Error@js.cpt js.cpt.Class ErrorNX
  cpt.Error = new Class("Error",
    null,
    "extension=.js,type=text/javascript,charset=Shift_JIS"
  );
  
  //:I Log@js.cpt js.cpt.Class ʃONX
  cpt.Log = new Class("Log",
    null,
    "extension=.js,type=text/javascript,charset=Shift_JIS"
  );
  
  }
)();

