var setIncludeBase = (function()
 /**
  * uEUpNX[_[̒ǉiNXpbP[Wc[j
  * @return Function setIncludeBase\bh
  * 
  * @update 2007/08/25
  * @version 1.02.02
  * @author Mug
  * @copyright (C) 2006-2007 Mug, All rights reserved.
  * 
  * @condition ysz
  *   <p>NXpbP[Wc[ǂݍ܂Ajs.cpt.Class, js.cpt.Package ̗NXĂԂł邱ƁB
  *   ܂AO[oIuWFNgȉ<var>Class</var>,<var>Package</var>̗ϐA<kbd>js.cpt.Class == Class</kbd><kbd>js.cpt.Package == Package</kbd>ł邱ƁB</p>
  * 
  * @explanation yIvVz
  *   <p>uL[=l,L[=l,cv̌`ł邱ƁBꂼ̕ɂ͈ȉgpłB
  *   <table border="1" cellspacing="0">
  *     <tbody>
  *       <tr><th>L[</th><td><kbd>ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789_-</kbd></td></tr>
  *       <tr><th>l</th>  <td><kbd>ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789_-+/%.:;</kbd></td></tr>
  *     </tbody>
  *   </table></p>
  * 
  * @explanation yx[XfBNg̐ݒz
  *   <p>x[XfBNg͐΃pX܂͑΃pXŎw肵Ȃ΂ȂȂB
  *   vgRzXg͎włȂBfBNgɂ͈ȉ̕gpłB
  *   <table border="1" cellspacing="0">
  *     <tbody>
  *       <tr><th>fBNg</th><td><kbd>ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789_-~.{}[]</kbd></td></tr>
  *       <tr><th>؂蕶</th>      <td><kbd>/</kbd></td></tr>
  *     </tbody>
  *   </table>
  *   ΃pX̏ꍇ͓ǂݍƂĂy[W̃pXƂȂB
  *   ܂A<strong>x[XfBNg\̍Ō͋؂蕶łȂ΂ȂȂB</strong></p>
  */
  {
  //------------------------------------------------------------------------------
  //:V GLOBAL_OBJ Object O[oIuWFNg
  var GLOBAL_OBJ = (function(){return this;})();
  //:V _CLASS_ js.cpt.Class ClassNX̎Q
  var _CLASS_ = js.cpt.Class;
  //:V _PACKAGE_ js.cpt.Package PackageNX̎Q
  var _PACKAGE_ = js.cpt.Package;
  //------------------------------------------------------------------------------
  // N`FbN
  if(!_CLASS_ || !_PACKAGE_ || !GLOBAL_OBJ.document)
    {
    throw new Error("uEUpNX[_[̒ǉɕKvȏsĂ܂B");
    }
  //------------------------------------------------------------------------------
  //:V DIR_REG_OBJ String fBNg\̐K\
  var DIR_REG_OBJ = /^\.{0,2}(?:\/\.\.)*\/(?:[0-9A-Za-z_\-~\.\{\}\[\]]+\/)*$/;
  //:V KEY_REG_OBJ String IvṼL[Ŏgp\ȕ̐K\
  var KEY_REG_OBJ = /^[0-9A-Za-z_\-]+$/;
  //:V VAL_REG_OBJ String IvV̒lŎgp\ȕ̐K\
  var VAL_REG_OBJ = /^[0-9A-Za-z_\-\+\/%\.\:;]+$/;
  //------------------------------------------------------------------------------
  function setIncludeBase(baseDirectory)
   /**
    * CN[hx[XfBNgݒ肷
    * @param baseDirectory String CN[hx[XfBNg(̍Ō͕K/)
    * @this js.cpt.Package ̃\bhthisjs.cpt.PackageIuWFNg܂̓O[oIuWFNgƂĎsȂ΂ȂȂB
    * @explanation ̃\bhsꂽƂthisƂȉjs.cpt.PackageIuWFNgɑ΂čċAIɐݒ肷B
    * @throw Error thisjs.cpt.PackageIuWFNgłO[oIuWFNgłȂꍇ
    * @throw Error baseDirectoryłȂł͂Ȃꍇ
    * @throw Error baseDirectoryw肳ꂽK\𖞂ĂȂꍇ
    * @example mug.is.creator pbP[Wȉ̃CN[hx[Xݒ肷ꍇ́A
    *          mug.is.creator.setIncludeBase("../../~mug/is/creator/");
    *          ̂悤ɁAmug.is.creator pbP[W̃NX݂fBNgw肷B
    */
    {
    if((this != null) && (GLOBAL_OBJ != this) && (this.constructor != null) && !(this instanceof _PACKAGE_) && !(this instanceof _CLASS_))
      {
      throw new Error("setIncludeBase\bhthislsłB");
      }
    if(!baseDirectory || ((typeof baseDirectory) != "string"))
      {
      throw new Error("setIncludeBasëbaseDirectoryłȂł͂܂B");
      }
    if(!DIR_REG_OBJ.test(baseDirectory))
      {
      throw new Error("setIncludeBasëbaseDirectoryK\/" + DIR_REG_OBJ.source + "/𖞂Ă܂B");
      }
    // ݒ
    if((this instanceof _PACKAGE_) || (this instanceof _CLASS_))
      {
      this.includeBaseDirectory = baseDirectory;
      this.settingIncludeBaseNow = true;
      }
    // lXgčċA
    if((this instanceof _PACKAGE_) || (GLOBAL_OBJ == this))  // Zp:IȄꍇ̂(GLOBAL_OBJ == this)(this == GLOBAL_OBJ)̌ʂႤ
      {
      for(var i in this)
        {
        var obj = null;
        try
          {
          obj = this[i];
          }
        catch(e)
          {
          obj = null;
          }
        if(obj && ((typeof obj) == "object") && ((obj instanceof _PACKAGE_) || (obj instanceof _CLASS_)))
          {
          if(!obj.settingIncludeBaseNow)
            {
            if(obj instanceof _PACKAGE_)
              {
              arguments.callee.call(obj, (baseDirectory + i + "/"));
              }
            else if(obj instanceof _CLASS_)
              {
              arguments.callee.call(obj, baseDirectory);
              }
            }
          }
        }
      }
    // ݒ߂
    if((this instanceof _PACKAGE_) || (this instanceof _CLASS_))
      {
      delete this.settingIncludeBaseNow;
      }
    }
  //------------------------------------------------------------------------------
  function ClassLoader()
   /**
    * uEUpNX[_[
    * @this js.cpt.Class ̃\bhthisjs.cpt.ClassIuWFNgƂĎsȂ΂ȂȂB
    * @throw Error thisjs.cpt.ClassIuWFNgłȂꍇ
    * @throw Error [hɎsA񕜕s\ȏꍇ
    */
    {
    if(!(this instanceof _CLASS_))
      {
      throw new Error("uEUpNX[_[thislsłB");
      }
    var baseDir = this.includeBaseDirectory;
    if(!baseDir || ((typeof baseDir) != "string") || !DIR_REG_OBJ.test(baseDir))
      {
      throw new Error("CN[hy[XfBNgݒ肳Ă܂B");
      }
    var opt = new Option(this.getOptions());
    var src = baseDir + this.getName() + (opt.extension ? opt.extension : "");
    var key = ["type", "language", "charset", "defer", "id", "class", "style"];
    // wb_ǂݍ݌̃[h(I[h)
    if(GLOBAL_OBJ.document.body)
      {
      var obj = GLOBAL_OBJ.document.createElement("script");
      obj.src = src;
      for(var i = 0; i < key.length; i++)
        {
        try
          {
          obj[key[i]] = opt[key[i]];
          }
        catch(e)
          {
          // ignore errors.
          }
        }
      GLOBAL_OBJ.document.body.parentNode.firstChild.appendChild(obj);
      }
    // wb_ǂݍݒ̃[h(ÓI[h)
    else
      {
      var tags = '<script';
      tags += ' src="' + src + '"';
      for(var i = 0; i < key.length; i++)
        {
        if(opt[key[i]])
          {
          tags += ' ' + key[i] + '="' + opt[key[i]] + '"';
          }
        }
      tags += '></' + 'script>';
      GLOBAL_OBJ.document.writeln(tags);
      }
    }
  //------------------------------------------------------------------------------
  function Option(options)
   /**
    * IvVێNX(pȈՃNX)
    * @param options String IvV
    * @return Option IvVIuWFNg
    */
    {
    if(options && ((typeof options) == "string"))
      {
      var dataList = options.split(",");
      for(var i = 0; i < dataList.length; i++)
        {
        var dataSet = dataList[i].split("=");
        var key     = dataSet[0];
        var value   = (dataSet.length > 1) ? dataSet[1] : null;
        if(key && KEY_REG_OBJ.test(key) && (this[key] === undefined))
          {
          this[key] = (value && VAL_REG_OBJ.test(value)) ? value : null;
          }
        }
      }
    return this;
    }
  //------------------------------------------------------------------------------
  // setIncludeBase\bh̃Zbg
  GLOBAL_OBJ.setIncludeBase = setIncludeBase;
  _PACKAGE_.prototype.setIncludeBase = setIncludeBase;
  //------------------------------------------------------------------------------
  // NX[_[̃Zbg
  _CLASS_.setClassLoader(ClassLoader);
  //------------------------------------------------------------------------------
  return setIncludeBase;
  }
)();

