Class.create(function(Super)
 /**
  * ۃK[A_v^[NX
  * @param Super [Function|null] X[p[NX
  * @return Function js.cpt.LogNX
  * 
  * @package js.cpt
  * @update 2007/08/25
  * @version 1.00.04
  * @author Mug
  * @copyright (C) 2006-2007 Mug, All rights reserved.
  * 
  * @explanation <p>ۂɓ삷郍K[͂̃NXpTuNXłȂ΂ȂȂB
  *   ̃NX̓TuNX̃A_v^[Ƃċ@\B
  *   ܂ÃNX̓Oo͂̃C^[tF[X肵Ă݂̂ŁA
  *   ̓IȃOo͏⏉iOo͐ݒ̃vpeB̐ݒEǂݍ݁Efj̕@̓TuNXɔCĂB</p>
  *   <p>TuNX͂P݂̂o^łȂAo^TuNXiƂɔEݒjύX݂̂ŁA
  *   Oõ͕\[XR[hύX邱ƂȂK[؂ւ邱ƂłB
  *   p邽߁AOo͕ł̓TuNXł͂ȂA
  *   ̃NX(<var>js.cpt.Log</var>)݂̂gpă\[XLqĂKvB</p>
  * @explanation <p><var>js.cpt.Log.setImplementedClass</var>\bhɂăTuNXo^ĂꍇA
  *   iƂ̃NXnewĂĂj̃TuNX̃CX^XĕԂB
  *   ܂ATuNXo^̏ꍇ͂̃NX̃CX^XԂ邪ǍTuNXo^
  *   ex̃Oo̓\bh̓TuNX̃\bh_CNgČĂяoB</p>
  *   <p>ۂɃOo͂ӏɂāÃNXnewăK[̃CX^X擾鎞_ł́A
  *   ɃTuNXo^ς݂ł邱Ƃ]܂Bo^łƂĂǍo^
  *   o^OɐCX^XłOo͂\ƂȂB</p>
  * @example <p>ႦΈȉ̃R[hɂāA<var>log1</var><var>log2</var>͎̂悤ȈႢ܂B<br />
  *   <var>log1</var>͂̃NX<var>js.cpt.Log</var>̒ڂ̃CX^Xł邪A
  *   <var>log2</var>̓TuNX<var>js.debug.log.Log</var>̃CX^XłB<br />
  *   ɂA<var>log2</var>̊ex̃Oo̓\bhi<var>info</var>Ȃǁj͒ڃTuNX̂̂s邪A
  *   <var>log1</var>̊ex̃Oo̓\bh<var>js.cpt.Log</var>TuNXփ_CNgĎsB</p>
  *   <p>AOo͂̏<var>log1</var><var>log2</var>ςȂB</p>
  *   <pre><code>
  *   var log1 = new js.cpt.Log("LogTest");  // ̎_ł̓TuNXo^
  *   log1.info("o͂ȂO");
  *   
  *   js.cpt.Log.setImplementedClass(js.debug.log.Log);  // Ⴆjs.debug.log.Logo^
  *   
  *   var log2 = new js.cpt.Log("LogTest");  // TuNXo^ɃCX^X
  *   log2.debug("o͂邩mȂO");
  *   
  *   log1.warn("log1Oo͂ł悤ɂȂĂB");
  *   
  *   var log1_is_ins_of_super = (log1 instanceof js.cpt.Log);  // true
  *   var log2_is_ins_of_super = (log2 instanceof js.cpt.Log);  // true
  *   var log1_is_ins_of_sub = (log1 instanceof js.debug.log.Log);  // false
  *   var log2_is_ins_of_sub = (log2 instanceof js.debug.log.Log);  // true
  *   </code></pre>
  */
  {
  //##############################################################################
  //
  // wb_(vpeBEpENXpX)
  //
  //
  // vpeB - NXɊւ郁^f[^
  //
  //:V Creator Function NXNG[^[
  var Creator = arguments.callee;
  // SCNX
  Creator.CompleteName = "js.cpt.Log";
  
  //
  // p - vg^CvpƊ{õZbg
  //
  // p
  Creator.inherit(Class, Super);
  //:V Static Object StaticIuWFNg
  var Static = Class.Static;
  //:V Proto Object vg^CvIuWFNg
  var Proto = Class.prototype;
  
  //
  // NXpX
  //
  
  //##############################################################################
  //
  // {fB(vCx[gENXEStaticEvg^CvE)
  //
  //
  // vCx[g - NX̔Joƃ\bh(pȂ)
  //
  //:V DEFAULT_LEVEL Number ftHgOx
  var DEFAULT_LEVEL = 2;
  //:V implementedClass Function|null Oo͂TuNX
  var implementedClass = null;
  
  //------------------------------------------------------------------------------
  function setInstanceRedirector(methodName)
   /**
    * TuNX̃CX^XɃ_CNg郁\bhݒ肷
    * @param methodName String \bh
    * @explanation <p>̃NX<var>prototype</var>IuWFNg̃\bh㏑A
    *   <kbd>this.setRedirectors()</kbd>sB</p>
    */
    {
    Proto[methodName] = function()
      {
      if((typeof this.setRedirectors) == "function")
        {
        this.setRedirectors();
        if(this[methodName] != Proto[methodName])
          {
          this[methodName].apply(this, arguments);
          }
        }
      };
    }
  //------------------------------------------------------------------------------
  function setInstanceRedirectors()
   /**
    * TuNX̃CX^XɃ_CNg郁\bhݒ肷
    * @explanation <p><var>setInstanceRedirector</var>\bhgA
    *   fatal,error,warn,info,debug,trace̊e\bhB</p>
    */
    {
    setInstanceRedirector("fatal");
    setInstanceRedirector("error");
    setInstanceRedirector("warn");
    setInstanceRedirector("info");
    setInstanceRedirector("debug");
    setInstanceRedirector("trace");
    };
  
  //
  // NX - NX̌Joƃ\bh(pȂ)
  //
  //------------------------------------------------------------------------------
  Class.setImplementedClass = function(subClass)
   /**
    * Oo͂TuNXo^
    * @param subClass Function js.cpt.Log̃TuNX
    * @throw FunctionFormatException@Error subClass֐łȂꍇ
    * @throw RangeException@Error subClassjs.cpt.Log̃TuNXłȂꍇ
    * @explanation <p>̃NXpK[iۂɃOo͂NXjAX[p[NXł邱̃NXɓo^B
    *   <em>o^łTuNX͂Pĩ\bȟĂяo͂Pĵ</em>łAs邱Ƃ͂łȂB</p>
    */
    {
    if((typeof subClass) != "function")
      {
      throw new Error("FunctionFormatException", Creator.CompleteName, {variable:"subClass", value:subClass, type:(typeof subClass)});
      }
    if(!(subClass.prototype instanceof Class))
      {
      throw new Error("RangeException", Creator.CompleteName, {variable:"subClass", range:"js.cpt.Log̃TuNX", value:subClass});
      }
    Class.setImplementedClass = null;
    delete Class.setImplementedClass;
    implementedClass = subClass;
    setInstanceRedirectors();
    };
  
  //
  // Static - NX.StatičJoƃ\bh(p)
  //
  //:S level Number Ox
  Static.level = DEFAULT_LEVEL;
  
  //:S LEVEL_NOLOG Number Oxnolog(Oo͂Ȃ)
  Static.LEVEL_NOLOG = -1;
  //:S LEVEL_FATAL Number Oxfatal
  Static.LEVEL_FATAL = 0;
  //:S LEVEL_ERROR Number Oxerror
  Static.LEVEL_ERROR = 1;
  //:S LEVEL_WARN Number Oxwarn
  Static.LEVEL_WARN  = 2;
  //:S LEVEL_INFO Number Oxinfo
  Static.LEVEL_INFO  = 3;
  //:S LEVEL_DEBUG Number Oxdebug
  Static.LEVEL_DEBUG = 4;
  //:S LEVEL_TRACE Number Oxtrace
  Static.LEVEL_TRACE = 5;
  
  //:S LEVEL_NAMES Object Ox(String)̃}bv(L[:xl,l:x)
  Static.LEVEL_NAMES = {};
  // js.cpt.Log.Static.LEVEL_NAMES[-1] String Ox"nolog"
  Static.LEVEL_NAMES[Static.LEVEL_NOLOG] = "NOLOG";
  // js.cpt.Log.Static.LEVEL_NAMES[0] String Ox"fatal"
  Static.LEVEL_NAMES[Static.LEVEL_FATAL] = "FATAL";
  // js.cpt.Log.Static.LEVEL_NAMES[1] String Ox"error"
  Static.LEVEL_NAMES[Static.LEVEL_ERROR] = "ERROR";
  // js.cpt.Log.Static.LEVEL_NAMES[2] String Ox"warn"
  Static.LEVEL_NAMES[Static.LEVEL_WARN]  = "WARN";
  // js.cpt.Log.Static.LEVEL_NAMES[3] String Ox"info"
  Static.LEVEL_NAMES[Static.LEVEL_INFO]  = "INFO";
  // js.cpt.Log.Static.LEVEL_NAMES[4] String Ox"debug"
  Static.LEVEL_NAMES[Static.LEVEL_DEBUG] = "DEBUG";
  // js.cpt.Log.Static.LEVEL_NAMES[5] String Ox"trace"
  Static.LEVEL_NAMES[Static.LEVEL_TRACE] = "TRACE";
  
  //
  // vg^Cv - NX.prototypěJoƃ\bh(p)
  //
  //------------------------------------------------------------------------------
  Proto.reset = function()
   /**
    * OxftHgɖ߂
    * @notice ̃\bh̓TuNXŃI[o[ChĎB
    * @explanation <p>TuNXł̓Ox𓮓IɕύX邱Ƃł邪A
    *   ̃\bhsꂽ̓OxԂɖ߂KvB
    *   ̕@̓TuNXɈˑB</p>
    */
    {
    };
  //------------------------------------------------------------------------------
  Proto.fatal = function()
   /**
    * fatalx̃Oo͂s
    * @notice ̃\bh̓TuNXŃI[o[ChĎB
    */
    {
    };
  //------------------------------------------------------------------------------
  Proto.error = function()
   /**
    * errorx̃Oo͂s
    * @notice ̃\bh̓TuNXŃI[o[ChĎB
    */
    {
    };
  //------------------------------------------------------------------------------
  Proto.warn = function()
   /**
    * warnx̃Oo͂s
    * @notice ̃\bh̓TuNXŃI[o[ChĎB
    */
    {
    };
  //------------------------------------------------------------------------------
  Proto.info = function()
   /**
    * infox̃Oo͂s
    * @notice ̃\bh̓TuNXŃI[o[ChĎB
    */
    {
    };
  //------------------------------------------------------------------------------
  Proto.debug = function()
   /**
    * debugx̃Oo͂s
    * @notice ̃\bh̓TuNXŃI[o[ChĎB
    */
    {
    };
  //------------------------------------------------------------------------------
  Proto.trace = function()
   /**
    * tracex̃Oo͂s
    * @notice ̃\bh̓TuNXŃI[o[ChĎB
    */
    {
    };
  
  //
  //  - NX`ɂP񂾂s
  //
  
  //##############################################################################
  //
  // RXgN^(vCx[gEthisERXgN^)
  //
  function Class(key)
   /**
    * LogNX̃RXgN^
    * @this js.cp.Log ̃NX܂̓TuNX̃CX^X
    * @param key [String] Oo̓L[(ʏ͊SCNXw)
    * @return js.cpt.Log (̃NX܂̓TuNX)CX^X
    * @explanation implementedClassݒ肳ĂƂÃNX̃CX^XԂB
    * @throw FormatException@Error thisl̃NX܂̓TuNX̃CX^XłȂꍇ
    */
    {
    if(!(this instanceof Class))
      {
      throw new Error("FormatException", Creator.CompleteName, {variable:"this", format:Creator.CompleteName, value:this, type:(typeof this)});
      }
    if((this instanceof Class) && (this.constructor == Class) && implementedClass)
      {
      return new implementedClass(key);
      }
    //
    // X[p[NXKp(p) - X[p[NX̃RXgN^N
    //
    //Super.apply(this, arguments);
    //
    // vCx[g - CX^X̔Joƃ\bh(pȂ)
    //
    //:v implementedInstance js.cpt.Log|null TuNX̃CX^X܂null
    var implementedInstance = null;
    
    //------------------------------------------------------------------------------
    function setRedirector(methodName)
     /**
      * TuNX̃CX^XɃ_CNg郁\bhgɒǉ
      * @param methodName String \bh
      * @explanation <p>TuNX̃CX^X̊ex̃Oo̓\bhɈSĂnĎsǍʂreturnB</p>
      */
      {
      if((this instanceof Class) && (this.constructor == Class) && implementedInstance && (this[methodName] == Proto[methodName]))
        {
        this[methodName] = function()
          {
          return implementedInstance[methodName].apply(implementedInstance, arguments);
          };
        }
      }
    //------------------------------------------------------------------------------
    function setRedirectors()
     /**
      * TuNX̃CX^XɃ_CNg郁\bhgɒǉ
      * @explanation <p><var>setRedirector</var>\bhgA
      *   fatal,error,warn,info,debug,trace̊e\bhB</p>
      */
      {
      if(!implementedInstance && implementedClass)
        {
        this.setRedirectors = null;
        delete this.setRedirectors;
        implementedInstance = new implementedClass(key);
        setRedirector.call(this, "fatal");
        setRedirector.call(this, "error");
        setRedirector.call(this, "warn");
        setRedirector.call(this, "info");
        setRedirector.call(this, "debug");
        setRedirector.call(this, "trace");
        }
      }
    
    //
    // this - CX^X̌Joƃ\bh(Kpɂp)
    //
    
    //
    // RXgN^ - CX^X̌Joƃ\bh(pȂ)
    //
    if((this instanceof Class) && (this.constructor != Class))
      {
      implementedInstance = this;
      }
    if((this instanceof Class) && (this.constructor == Class))
      {
      this.setRedirectors = setRedirectors;
      }
    return this;
    }
  
  return Class;
  });

